diff --git a/tests/test_toulouse_maelis.py b/tests/test_toulouse_maelis.py
index 0907c98f..3f5556ca 100644
--- a/tests/test_toulouse_maelis.py
+++ b/tests/test_toulouse_maelis.py
@@ -16,17 +16,17 @@
 import logging
 import os
 from unittest import mock
 
 import pytest
 from lxml import etree
 from requests.exceptions import ConnectionError
 
-from passerelle.contrib.toulouse_maelis.models import Link, ToulouseMaelis
+from passerelle.contrib.toulouse_maelis.models import Link, Referential, ToulouseMaelis
 from passerelle.utils.jsonresponse import APIError
 from passerelle.utils.soap import SOAPError
 from tests.utils import FakedResponse, generic_endpoint_url, setup_access_rights
 
 TEST_BASE_DIR = os.path.join(os.path.dirname(__file__), 'data', 'toulouse_maelis')
 
 
 def get_xml_file(filename):
@@ -40,30 +40,16 @@ ACTIVITY_SERVICE_WSDL = FakedResponse(content=get_xml_file('ActivityService.wsdl
 INVOICE_SERVICE_WSDL = FakedResponse(content=get_xml_file('InvoiceService.wsdl'), status_code=200)
 FAILED_AUTH = FakedResponse(content=get_xml_file('R_failed_authentication.xml'), status_code=500)
 ISWSRUNNING_TRUE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'true', status_code=200)
 ISWSRUNNING_FALSE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'false', status_code=200)
 READ_FAMILY = FakedResponse(content=get_xml_file('R_read_family.xml'), status_code=200)
 READ_FAMILY_LAX = FakedResponse(content=get_xml_file('R_read_family_relax.xml'), status_code=200)
 READ_FAMILY_ORD = FakedResponse(content=get_xml_file('R_read_family_reordered.xml'), status_code=200)
 READ_RL1_FAMILY = FakedResponse(content=get_xml_file('R_read_family_with_only_rl1.xml'), status_code=200)
-READ_CATEGORIES = FakedResponse(content=get_xml_file('R_read_category_list.xml'), status_code=200)
-READ_CHILD_INDICATOR = FakedResponse(content=get_xml_file('R_read_child_indicator_list.xml'), status_code=200)
-READ_CIVILITIES = FakedResponse(content=get_xml_file('R_read_civility_list.xml'), status_code=200)
-READ_COUNTRY = FakedResponse(content=get_xml_file('R_read_country_list.xml'), status_code=200)
-READ_CSP = FakedResponse(content=get_xml_file('R_read_csp_list.xml'), status_code=200)
-READ_DIETCODE = FakedResponse(content=get_xml_file('R_read_dietcode_list.xml'), status_code=200)
-READ_ORGAN = FakedResponse(content=get_xml_file('R_read_organ_list.xml'), status_code=200)
-READ_PAI = FakedResponse(content=get_xml_file('R_read_pai_list.xml'), status_code=200)
-READ_QUALITIES = FakedResponse(content=get_xml_file('R_read_quality_list.xml'), status_code=200)
-READ_QUOTIENT = FakedResponse(content=get_xml_file('R_read_quotient_list.xml'), status_code=200)
-READ_RL_INDICATOR = FakedResponse(content=get_xml_file('R_read_rl_indicator_list.xml'), status_code=200)
-READ_SITUATIONS = FakedResponse(content=get_xml_file('R_read_situation_list.xml'), status_code=200)
-READ_STREET = FakedResponse(content=get_xml_file('R_read_street_list.xml'), status_code=200)
-READ_VACCIN = FakedResponse(content=get_xml_file('R_read_vaccin_list.xml'), status_code=200)
 IS_RL_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'true', status_code=200)
 IS_RL_EXISTS_FALSE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'false', status_code=200)
 IS_CHILD_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_child_exists.xml') % b'true', status_code=200)
 IS_CHILD_EXISTS_FALSE = FakedResponse(
     content=get_xml_file('R_is_child_exists.xml') % b'false', status_code=200
 )
 CREATE_FAMILY = FakedResponse(content=get_xml_file('R_create_family.xml'), status_code=200)
 CREATE_FAMILY_ERR = FakedResponse(content=get_xml_file('R_create_family_error.xml'), status_code=200)
@@ -100,16 +86,44 @@ def con(db):
         ToulouseMaelis.objects.create(
             slug='test',
             zeep_wsse_username='maelis-webservice',
             zeep_wsse_password='maelis-password',
         )
     )
 
 
+@pytest.fixture
+def ref(con, caplog):
+    mocked_get = mock.patch('passerelle.utils.Request.get', return_value=FAMILY_SERVICE_WSDL)
+    mocked_post = mock.patch(
+        'passerelle.utils.Request.post',
+        side_effect=[
+            FakedResponse(content=get_xml_file('R_read_category_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_child_indicator_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_civility_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_country_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_csp_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_dietcode_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_organ_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_pai_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_quality_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_quotient_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_rl_indicator_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_situation_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_street_list.xml'), status_code=200),
+            FakedResponse(content=get_xml_file('R_read_vaccin_list.xml'), status_code=200),
+        ],
+    )
+    mocked_get.start()
+    mocked_post.start()
+    con.daily()
+    assert caplog.messages[-1] == 'Réferentiels mis à jour.'
+
+
 @mock.patch('passerelle.utils.Request.get')
 def test_call_with_wrong_wsdl_url(mocked_get, con):
     mocked_get.side_effect = CONNECTION_ERROR
     with pytest.raises(
         SOAPError,
         match='cannot be loaded: No address associated with hostname',
     ) as e:
         con.call('Family', 'isWSRunning')
@@ -201,16 +215,62 @@ def test_replace_null_values(con):
             'street1': 'Chateau',
             'street2': '',
             'town': 'Paris',
             'zipcode': '75014',
         }
     }
 
 
+@mock.patch('passerelle.utils.Request.get')
+def test_update_referential(mocked_get, con):
+    mocked_get.return_value = FAMILY_SERVICE_WSDL
+
+    with mock.patch('passerelle.utils.Request.post') as mocked_post:
+        mocked_post.return_value = FakedResponse(
+            content=get_xml_file('R_read_category_list.xml'), status_code=200
+        )
+        con.update_referential('Category')
+        assert [
+            (x.item_id, x.item_text) for x in Referential.objects.filter(referential_name='Category')
+        ] == [('BI', 'BIPARENTALE'), ('ACCEUI', "FAMILLE D'ACCUEIL"), ('MONO', 'MONOPARENTALE')]
+
+    with mock.patch('passerelle.utils.Request.post') as mocked_post:
+        mocked_post.return_value = FakedResponse(
+            content=get_xml_file('R_read_category_list_2_items.xml'), status_code=200
+        )
+        con.update_referential('Category')
+        assert [
+            (x.item_id, x.item_text) for x in Referential.objects.filter(referential_name='Category')
+        ] == [('BI', 'BIPARENTALE'), ('ACCEUI', 'Famille acceuillante')]
+
+
+def test_cron(ref):
+    assert Referential.objects.filter(referential_name='Category').count() == 3
+    assert sorted(list({x.referential_name for x in Referential.objects.all()})) == [
+        'CSP',
+        'Category',
+        'ChildIndicator',
+        'Civility',
+        'Complement',
+        'Country',
+        'DietCode',
+        'Organ',
+        'PAI',
+        'Quality',
+        'Quotient',
+        'RLIndicator',
+        'Sex',
+        'Situation',
+        'Street',
+        'Vaccin',
+    ]
+    assert Referential.objects.count() == 230
+
+
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
 def test_link(mocked_post, mocked_get, con, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
     mocked_post.return_value = READ_FAMILY
     url = get_endpoint('link')
     assert Link.objects.count() == 0
 
@@ -256,96 +316,63 @@ def test_unlink(con, app):
     assert resp.json['err'] == 0
     assert resp.json['data'] == 'ok'
 
     resp = app.post_json(url + '?NameID=local')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_get_referential_using_cache(mocked_post, mocked_get, con, freezer):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CATEGORIES
-
-    freezer.move_to('2021-11-10 00:00')
-    con.get_referential('Category')
-    assert mocked_post.call_count == 1
-
-    con.get_referential('Category')
-    assert mocked_post.call_count == 1
-
-    freezer.move_to('2021-11-10 02:00')
-    con.get_referential('Category')
-    assert mocked_post.call_count == 2
-
+def test_get_referential(con, ref):
+    assert con.get_referential('Category') == [
+        {'code': 'BI', 'id': 'BI', 'libelle': 'BIPARENTALE', 'text': 'BIPARENTALE'},
+        {'code': 'ACCEUI', 'id': 'ACCEUI', 'libelle': "FAMILLE D'ACCUEIL", 'text': "FAMILLE D'ACCUEIL"},
+        {'code': 'MONO', 'id': 'MONO', 'libelle': 'MONOPARENTALE', 'text': 'MONOPARENTALE'},
+    ]
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_get_referential_value(mocked_post, mocked_get, con):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CSP
 
+def test_get_referential_value(con, ref):
     assert con.get_referential_value('CSP', '1') == 'AGRICULTEUR'
     assert con.get_referential_value('CSP', 'AGR') == 'AGRICULTEUR'
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_get_referential_value_not_found(mocked_post, mocked_get, con, caplog):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CIVILITIES
-
+def test_get_referential_value_not_found(con, ref, caplog):
     assert con.get_referential_value('Civility', 'MR') == 'MR'
     assert len(caplog.records) == 1
     assert caplog.records[0].levelno == logging.WARNING
     assert caplog.records[0].message == "No 'MR' key into Maelis 'Civility' referential"
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_category_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CATEGORIES
+def test_read_category_list(con, ref, app):
     url = get_endpoint('read-category-list')
 
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
-        {'id': 'BI', 'text': 'BIPARENTALE'},
-        {'id': 'ACCEUI', 'text': "FAMILLE D'ACCUEIL"},
-        {'id': 'MONO', 'text': 'MONOPARENTALE'},
+        {'id': 'BI', 'text': 'BIPARENTALE', 'code': 'BI', 'libelle': 'BIPARENTALE'},
+        {'id': 'ACCEUI', 'text': "FAMILLE D'ACCUEIL", 'code': 'ACCEUI', 'libelle': "FAMILLE D'ACCUEIL"},
+        {'id': 'MONO', 'text': 'MONOPARENTALE', 'code': 'MONO', 'libelle': 'MONOPARENTALE'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_country_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_COUNTRY
+def test_read_country_list(con, ref, app):
     url = get_endpoint('read-country-list')
 
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 3
     assert resp.json['data'] == [
-        {'id': '212', 'text': 'AFGHANISTAN'},
-        {'id': '303', 'text': 'AFRIQUE DU SUD'},
-        {'id': '125', 'text': 'ALBANIE'},
+        {'id': '212', 'code': '212', 'text': 'AFGHANISTAN', 'libelle': 'AFGHANISTAN'},
+        {'id': '303', 'code': '303', 'text': 'AFRIQUE DU SUD', 'libelle': 'AFRIQUE DU SUD'},
+        {'id': '125', 'code': '125', 'text': 'ALBANIE', 'libelle': 'ALBANIE'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_child_indicator_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CHILD_INDICATOR
+def test_read_child_indicator_list(con, ref, app):
     url = get_endpoint('read-child-indicator-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 8
     assert resp.json['data'][0:2] == [
         {
             'id': 'AUTRE',
             'text': 'Autre',
             'choiceList': [],
@@ -359,196 +386,131 @@ def test_read_child_indicator_list(mocked_post, mocked_get, con, app):
             'choiceList': [],
             'code': 'AVL',
             'label': 'Auxiliaire de Vie loisirs',
             'typeDesc': 'NONE',
         },
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_civility_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CIVILITIES
+def test_read_civility_list(con, ref, app):
     url = get_endpoint('read-civility-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
-        {"id": "MME", "text": "Madame"},
-        {"id": "M.", "text": "Monsieur"},
+        {'id': 'MME', 'code': 'MME', 'text': 'Madame', 'libelle': 'Madame'},
+        {'id': 'M.', 'code': 'M.', 'text': 'Monsieur', 'libelle': 'Monsieur'},
     ]
 
 
-def test_read_complement_list(con, app):
+def test_read_complement_list(con, ref, app):
     url = get_endpoint('read-complement-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
         {'id': 'B', 'text': 'bis'},
         {'id': 'Q', 'text': 'quater'},
         {'id': 'T', 'text': 'ter'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_csp_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_CSP
+def test_read_csp_list(con, ref, app):
     url = get_endpoint('read-csp-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
-    assert resp.json['data'] == [
-        {'id': '14', 'text': 'AGENT DE MAITRISE'},
-        {'id': '1', 'text': 'AGRICULTEUR'},
-        {'id': 'ART', 'text': 'ARTISAN'},
-        {'id': '2', 'text': 'ARTISAN-COMMERCANT'},
-        {'id': '15', 'text': 'AUTRES'},
-        {'id': '4', 'text': 'CADRE'},
-        {'id': '13', 'text': 'CADRE SUPERIEUR'},
-        {'id': '3', 'text': "CHEF D'ENTREPRISE"},
-        {'id': 'CHOM', 'text': 'CHOMEUR'},
-        {'id': '7', 'text': 'COMMERCANT'},
-        {'id': '10', 'text': "DEMANDEUR D'EMPLOI"},
-        {'id': 'DIV', 'text': 'DIVERS'},
-        {'id': '5', 'text': 'EMPLOYE'},
-        {'id': '17', 'text': 'ENSEIGNANT'},
-        {'id': '8', 'text': 'ETUDIANT'},
-        {'id': '11', 'text': 'FONCTIONNAIRE'},
-        {'id': 'MAIR', 'text': 'MAIRIE DE NICE'},
-        {'id': '6', 'text': 'OUVRIER'},
-        {'id': 'PERENS', 'text': 'PERISCO ENSEIGNANT'},
-        {'id': 'PEREXT', 'text': 'PERISCO EXTERNE'},
-        {'id': 'PERMAI', 'text': 'PERISCO MAIRIE DE NICE'},
-        {'id': 'PERANI', 'text': 'PERISCO S.ANIMATION'},
-        {'id': '9', 'text': 'PROFESSION LIBERALE'},
-        {'id': '12', 'text': 'RETRAITE'},
-        {'id': 'RMI', 'text': "REVENU MINIMUM D'INSERTION"},
-        {'id': '16', 'text': 'SANS PROFESSION'},
-        {'id': 'SEC', 'text': 'SECRETAIRE'},
+    assert resp.json['data'][:5] == [
+        {'code': '14', 'id': '14', 'libelle': 'AGENT DE MAITRISE', 'text': 'AGENT DE MAITRISE'},
+        {'code': '1', 'id': '1', 'libelle': 'AGRICULTEUR', 'text': 'AGRICULTEUR'},
+        {'code': 'ART', 'id': 'ART', 'libelle': 'ARTISAN', 'text': 'ARTISAN'},
+        {'code': '2', 'id': '2', 'libelle': 'ARTISAN-COMMERCANT', 'text': 'ARTISAN-COMMERCANT'},
+        {'code': '15', 'id': '15', 'libelle': 'AUTRES', 'text': 'AUTRES'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_dietcode_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_DIETCODE
+def test_read_dietcode_list(con, ref, app):
     url = get_endpoint('read-dietcode-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
-        {'id': 'STD', 'text': '1- REPAS STANDARD'},
-        {'id': 'RSP', 'text': '2- RÉGIME SANS PORC'},
-        {'id': 'RSV', 'text': '3- RÉGIME SANS VIANDE'},
-        {'id': 'PAI', 'text': "4- PROTOCOLE D'ACCUEIL INDIVIDUALISÉ"},
-        {'id': 'BB', 'text': 'REPAS BEBE'},
-        {'id': 'MSP', 'text': 'REPAS MOYEN SANS PORC'},
-        {'id': 'MSV', 'text': 'REPAS MOYEN SANS VIANDE'},
-        {'id': 'MST', 'text': 'REPAS MOYEN STANDARD'},
+        {'id': 'STD', 'code': 'STD', 'text': '1- REPAS STANDARD', 'libelle': '1- REPAS STANDARD'},
+        {'id': 'RSP', 'code': 'RSP', 'text': '2- RÉGIME SANS PORC', 'libelle': '2- RÉGIME SANS PORC'},
+        {'id': 'RSV', 'code': 'RSV', 'text': '3- RÉGIME SANS VIANDE', 'libelle': '3- RÉGIME SANS VIANDE'},
+        {
+            'id': 'PAI',
+            'code': 'PAI',
+            'text': "4- PROTOCOLE D'ACCUEIL INDIVIDUALISÉ",
+            'libelle': "4- PROTOCOLE D'ACCUEIL INDIVIDUALISÉ",
+        },
+        {'id': 'BB', 'code': 'BB', 'text': 'REPAS BEBE', 'libelle': 'REPAS BEBE'},
+        {'id': 'MSP', 'code': 'MSP', 'text': 'REPAS MOYEN SANS PORC', 'libelle': 'REPAS MOYEN SANS PORC'},
+        {'id': 'MSV', 'code': 'MSV', 'text': 'REPAS MOYEN SANS VIANDE', 'libelle': 'REPAS MOYEN SANS VIANDE'},
+        {'id': 'MST', 'code': 'MST', 'text': 'REPAS MOYEN STANDARD', 'libelle': 'REPAS MOYEN STANDARD'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_organ_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_ORGAN
+def test_read_organ_list(con, ref, app):
     url = get_endpoint('read-organ-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 92
     assert resp.json['data'][:5] == [
-        {'id': 'A10000979374', 'text': 'ALC L OLIVIER'},
-        {'id': 'A10000979372', 'text': 'ALVA 06'},
-        {'id': 'A10000980566', 'text': 'ANTIBES'},
-        {'id': 'A10000980388', 'text': 'APAJH'},
-        {'id': 'A10016401771', 'text': 'ASCROS'},
+        {'id': 'A10000979374', 'code': 'ALC L OLIVIER', 'text': 'ALC L OLIVIER', 'libelle': None},
+        {'id': 'A10000979372', 'code': 'ALVA 06', 'text': 'ALVA 06', 'libelle': None},
+        {'id': 'A10000980566', 'code': 'ANTIBES', 'text': 'ANTIBES', 'libelle': None},
+        {'id': 'A10000980388', 'code': 'APAJH', 'text': 'APAJH', 'libelle': None},
+        {'id': 'A10016401771', 'code': 'ASCROS', 'text': 'ASCROS', 'libelle': None},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_pai_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_PAI
+def test_read_pai_list(con, ref, app):
     url = get_endpoint('read-pai-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
-        {'id': 'PAIALI', 'text': 'ALIMENTAIRE'},
-        {'id': 'PAIO', 'text': 'AUTRE'},
-        {'id': 'PAIMED', 'text': 'MEDICAL'},
-        {'id': 'PAI2', 'text': 'MEDICAL ET ALIMENTAIRE'},
+        {'id': 'PAIALI', 'code': 'PAIALI', 'text': 'ALIMENTAIRE', 'libelle': 'ALIMENTAIRE'},
+        {'id': 'PAIO', 'code': 'PAIO', 'text': 'AUTRE', 'libelle': 'AUTRE'},
+        {'id': 'PAIMED', 'code': 'PAIMED', 'text': 'MEDICAL', 'libelle': 'MEDICAL'},
+        {'id': 'PAI2', 'code': 'PAI2', 'text': 'MEDICAL ET ALIMENTAIRE', 'libelle': 'MEDICAL ET ALIMENTAIRE'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_quality_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_QUALITIES
+def test_read_quality_list(con, ref, app):
     url = get_endpoint('read-quality-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
-    assert resp.json['data'] == [
-        {'id': 'AU', 'text': 'AUTRE'},
-        {'id': 'BP', 'text': 'BEAU PERE'},
-        {'id': 'BM', 'text': 'BELLE MERE'},
-        {'id': 'CONSO', 'text': 'CONSOMMATEUR'},
-        {'id': 'EN', 'text': 'ENFANT'},
-        {'id': 'FS', 'text': 'FRERES ET SOEURS'},
-        {'id': 'GM', 'text': 'GRAND MERE MATERNELLE'},
-        {'id': 'GP', 'text': 'GRAND PERE MATERNEL'},
-        {'id': 'GMP', 'text': 'GRAND-MERE PATERNELLE'},
-        {'id': 'GPP', 'text': 'GRAND-PERE PATERNEL'},
-        {'id': 'MAIRIE', 'text': 'MAIRIE'},
-        {'id': 'MERE', 'text': 'MERE'},
-        {'id': 'O', 'text': 'ONCLE'},
-        {'id': 'OS', 'text': 'ORGANISME SOCIAL'},
-        {'id': 'PERE', 'text': 'PERE'},
-        {'id': 'T', 'text': 'TANTE'},
-        {'id': 'TUTEUR', 'text': 'TUTEUR'},
+    assert resp.json['data'][:5] == [
+        {'id': 'AU', 'code': 'AU', 'text': 'AUTRE', 'libelle': 'AUTRE'},
+        {'id': 'BP', 'code': 'BP', 'text': 'BEAU PERE', 'libelle': 'BEAU PERE'},
+        {'id': 'BM', 'code': 'BM', 'text': 'BELLE MERE', 'libelle': 'BELLE MERE'},
+        {'id': 'CONSO', 'code': 'CONSO', 'text': 'CONSOMMATEUR', 'libelle': 'CONSOMMATEUR'},
+        {'id': 'EN', 'code': 'EN', 'text': 'ENFANT', 'libelle': 'ENFANT'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_quotient_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_QUOTIENT
+def test_read_quotient_list(con, ref, app):
     url = get_endpoint('read-quotient-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
-        {'id': 'QF', 'text': 'GRILLE DE QUOTIENT'},
-        {'id': 'QCLSH', 'text': 'QUOTIENT CENTRE AERE'},
-        {'id': 'QJEU', 'text': 'QUOTIENT JEUNESSE'},
-        {'id': 'QS', 'text': 'QUOTIENT SCOLAIRE'},
-        {'id': 'QSPORT', 'text': 'QUOTIENT SPORT'},
-        {'id': 'MOY ECO', 'text': 'REVENU MOYEN ( MENSUEL OU ANNUEL)'},
+        {'id': 'QF', 'code': 'QF', 'text': 'GRILLE DE QUOTIENT', 'libelle': 'GRILLE DE QUOTIENT'},
+        {'id': 'QCLSH', 'code': 'QCLSH', 'text': 'QUOTIENT CENTRE AERE', 'libelle': 'QUOTIENT CENTRE AERE'},
+        {'id': 'QJEU', 'code': 'QJEU', 'text': 'QUOTIENT JEUNESSE', 'libelle': 'QUOTIENT JEUNESSE'},
+        {'id': 'QS', 'code': 'QS', 'text': 'QUOTIENT SCOLAIRE', 'libelle': 'QUOTIENT SCOLAIRE'},
+        {'id': 'QSPORT', 'code': 'QSPORT', 'text': 'QUOTIENT SPORT', 'libelle': 'QUOTIENT SPORT'},
+        {
+            'id': 'MOY ECO',
+            'code': 'MOY ECO',
+            'text': 'REVENU MOYEN ( MENSUEL OU ANNUEL)',
+            'libelle': 'REVENU MOYEN ( MENSUEL OU ANNUEL)',
+        },
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_rl_indicator_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_RL_INDICATOR
+def test_read_rl_indicator_list(con, ref, app):
     url = get_endpoint('read-rl-indicator-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 4
     assert resp.json['data'][1:3] == [
         {
             'id': 'AVS',
             'text': 'Auxiliaire de Vie scolaire',
             'choiceList': [],
@@ -562,101 +524,92 @@ def test_read_rl_indicator_list(mocked_post, mocked_get, con, app):
             'choiceList': [],
             'code': 'ETABSPEC',
             'label': 'Etablissement spécialisé',
             'typeDesc': 'NOTE',
         },
     ]
 
 
-def test_read_sex_list(con, app):
+def test_read_sex_list(con, app, ref):
     url = get_endpoint('read-sex-list')
 
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
         {'id': 'F', 'text': 'Féminin'},
         {'id': 'M', 'text': 'Masculin'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_situation_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_SITUATIONS
+def test_read_situation_list(con, ref, app):
     url = get_endpoint('read-situation-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
-    assert resp.json['data'] == [
-        {'id': 'C', 'text': 'Célibataire'},
-        {'id': 'D', 'text': 'Divorcé (e)'},
-        {'id': 'CS', 'text': 'EN COURS DE SEPARATION'},
-        {'id': 'M', 'text': 'Marié (e)'},
-        {'id': 'P', 'text': 'Pacsé (e)'},
-        {'id': 'S', 'text': 'Séparé (e)'},
-        {'id': 'UL', 'text': 'UNION LIBRE'},
-        {'id': 'V', 'text': 'Veuf (ve)'},
-        {'id': 'VM', 'text': 'Vivant maritalement'},
+    assert resp.json['data'][:5] == [
+        {'id': 'C', 'code': 'C', 'text': 'Célibataire', 'libelle': 'Célibataire'},
+        {'id': 'D', 'code': 'D', 'text': 'Divorcé (e)', 'libelle': 'Divorcé (e)'},
+        {'id': 'CS', 'code': 'CS', 'text': 'EN COURS DE SEPARATION', 'libelle': 'EN COURS DE SEPARATION'},
+        {'id': 'M', 'code': 'M', 'text': 'Marié (e)', 'libelle': 'Marié (e)'},
+        {'id': 'P', 'code': 'P', 'text': 'Pacsé (e)', 'libelle': 'Pacsé (e)'},
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_street_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_STREET
+def test_read_street_list(con, ref, app):
     url = get_endpoint('read-street-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 3
     assert resp.json['data'] == [
-        {'id': 'AP0594', 'text': 'AVENUE PAULIANI'},
-        {'id': 'AS0264', 'text': 'RUE SAINT FRANCOIS DE PAULE'},
-        {'id': 'AM0330', 'text': 'TRAVERSE DES MARAICHERS'},
+        {'id': 'AP0594', 'text': 'AVENUE PAULIANI', 'idStreet': 'AP0594', 'libelleStreet': 'AVENUE PAULIANI'},
+        {
+            'id': 'AS0264',
+            'text': 'RUE SAINT FRANCOIS DE PAULE',
+            'idStreet': 'AS0264',
+            'libelleStreet': 'RUE SAINT FRANCOIS DE PAULE',
+        },
+        {
+            'id': 'AM0330',
+            'text': 'TRAVERSE DES MARAICHERS',
+            'idStreet': 'AM0330',
+            'libelleStreet': 'TRAVERSE DES MARAICHERS',
+        },
     ]
 
 
-@mock.patch('passerelle.utils.Request.get')
-@mock.patch('passerelle.utils.Request.post')
-def test_read_vaccin_list(mocked_post, mocked_get, con, app):
-    mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.return_value = READ_VACCIN
+def test_read_vaccin_list(con, ref, app):
     url = get_endpoint('read-vaccin-list')
-
     resp = app.get(url)
     assert resp.json['err'] == 0
     assert len(resp.json['data']) == 20
     assert resp.json['data'][:5] == [
-        {'id': 'BCG', 'text': 'BCG'},
-        {'id': 'CIB', 'text': 'CONTRE-INDICATION  TEMPORAIRE AU BCG'},
-        {'id': 'MONO', 'text': 'CONTROLE DU BCG (+)'},
-        {'id': 'MONON', 'text': 'CONTROLE DU BCG (-)'},
-        {'id': 'DTC', 'text': 'DIPHTERIE TETANOS COQUELUCHE'},
+        {'id': 'BCG', 'code': 'BCG', 'text': 'BCG', 'libelle': 'BCG'},
+        {
+            'id': 'CIB',
+            'code': 'CIB',
+            'text': 'CONTRE-INDICATION  TEMPORAIRE AU BCG',
+            'libelle': 'CONTRE-INDICATION  TEMPORAIRE AU BCG',
+        },
+        {'id': 'MONO', 'code': 'MONO', 'text': 'CONTROLE DU BCG (+)', 'libelle': 'CONTROLE DU BCG (+)'},
+        {'id': 'MONON', 'code': 'MONON', 'text': 'CONTROLE DU BCG (-)', 'libelle': 'CONTROLE DU BCG (-)'},
+        {
+            'id': 'DTC',
+            'code': 'DTC',
+            'text': 'DIPHTERIE TETANOS COQUELUCHE',
+            'libelle': 'DIPHTERIE TETANOS COQUELUCHE',
+        },
     ]
 
 
 @pytest.mark.parametrize("read_family", [READ_FAMILY, READ_FAMILY_LAX, READ_FAMILY_ORD])
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
-def test_read_family(mocked_post, mocked_get, read_family, con, app):
+def test_read_family(mocked_post, mocked_get, read_family, con, ref, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.side_effect = [
-        read_family,
-        READ_CATEGORIES,
-        READ_SITUATIONS,
-        READ_CIVILITIES,
-        READ_QUALITIES,
-        READ_CSP,
-        READ_ORGAN,
-        READ_DIETCODE,
-        READ_PAI,
-    ]
+    mocked_post.return_value = read_family
     url = get_endpoint('read-family')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local')
     assert resp.json['err'] == 0
     data = resp.json['data']
     del data['RL1']
     del data['RL2']
@@ -827,43 +780,32 @@ def test_read_family_not_linked_error(con, app):
 
     resp = app.get(url + '?NameID=')
     assert resp.json['err'] == 'not-linked'
     assert resp.json['err_desc'] == 'User not linked to family'
 
 
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
-def test_read_rl1(mocked_post, mocked_get, con, app):
+def test_read_rl1(mocked_post, mocked_get, con, ref, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.side_effect = [
-        READ_FAMILY,
-        READ_CIVILITIES,
-        READ_QUALITIES,
-        READ_CSP,
-    ]
+    mocked_post.return_value = READ_FAMILY
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=613878')
     assert resp.json['err'] == 0
     assert resp.json['data']['firstname'] == 'JHON'
 
 
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
-def test_read_rl2(mocked_post, mocked_get, con, app):
+def test_read_rl2(mocked_post, mocked_get, con, ref, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
-    mocked_post.side_effect = [
-        READ_FAMILY,
-        READ_CIVILITIES,
-        READ_QUALITIES,
-        READ_CSP,
-        READ_ORGAN,
-    ]
+    mocked_post.return_value = READ_FAMILY
     url = get_endpoint('read-rl')
     Link.objects.create(resource=con, family_id='1312', name_id='local')
 
     resp = app.get(url + '?NameID=local&rl_id=613879')
     assert resp.json['err'] == 0
     assert resp.json['data'] == {
         'num': '613879',
         'lastname': 'DOE',
